# PUT /paymentmethod/{{customer_id}} — Update Payment Method For Existing Customer

> Product: **Pabbly Subscription Billing** (v1)
> Base URL: `https://payments.pabbly.com/api/v1`
> Auth: Basic via `Authorization` header
> Canonical: `/subscription-billing/payment-method/update-payment-method-for-existing-customer`

Can be fired to update the payment method for an existing customer. customer_id will be added in the Request URL. In response you will get a success message and the next recurring billing of this customer will be deducted from the newly added card.

**Path parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| customer_id | string | Yes |  |

**Body parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| card_number | string | No |  |
| month | string | No |  |
| year | string | No |  |
| cvv | string | No |  |
| mid | string | Yes | You will need to fire List all payment method API to get the MID. |
| Card Details | string | Yes | Card Number, Expiry and CVV will be added in the respective fields. These details will be stored in the payment gateways only. |

**Example request body:**

```json
{
  "card_number": "4111111111111111",
  "month": "11",
  "year": "2020",
  "cvv" : "423",
  "mid":"5e5f454c3b2518365c7923f4"
}
```

**Response (200)** — Update Payment Method For Existing Customer:

```json
{
    "status": "success",
    "message": "Payment method updated"
}
```

**Code examples:**

_cURL_

```curl
curl -X PUT https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}} \
  -u {{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}} \
  -H "Content-Type: application/json" \
  -d '{
    "card_number": "4111111111111111",
    "month": "11",
    "year": "2020",
    "cvv": "423",
    "mid": "5e5f454c3b2518365c7923f4"
  }'
```

_Ruby_

```ruby
require 'net/http'
require 'json'

uri = URI('https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}}')
request = Net::HTTP::Put.new(uri)
request.basic_auth '{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'
request['Content-Type'] = 'application/json'
request.body = "{\"card_number\":\"4111111111111111\",\"month\":\"11\",\"year\":\"2020\",\"cvv\":\"423\",\"mid\":\"5e5f454c3b2518365c7923f4\"}"

response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == 'https') do |http|
  http.request(request)
end

data = JSON.parse(response.body)
```

_Python_

```python
import requests
from requests.auth import HTTPBasicAuth

response = requests.put(
    'https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}}',
    auth=HTTPBasicAuth('{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'),
    json={
    'card_number': '4111111111111111',
    'month': '11',
    'year': '2020',
    'cvv': '423',
    'mid': '5e5f454c3b2518365c7923f4'
},
)

data = response.json()
```

_PHP_

```php
<?php
$ch = curl_init('https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}}');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
curl_setopt($ch, CURLOPT_USERPWD, '{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}');
curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
curl_setopt($ch, CURLOPT_POSTFIELDS, '{"card_number":"4111111111111111","month":"11","year":"2020","cvv":"423","mid":"5e5f454c3b2518365c7923f4"}');

$response = curl_exec($ch);
curl_close($ch);
$data = json_decode($response, true);
```

_Java_

```java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.Base64;

String credentials = Base64.getEncoder().encodeToString("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}".getBytes());

HttpClient client = HttpClient.newHttpClient();
HttpRequest.Builder builder = HttpRequest.newBuilder()
    .uri(URI.create("https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}}"))
    .header("Authorization", "Basic " + credentials)
    .header("Content-Type", "application/json")
    .PUT(HttpRequest.BodyPublishers.ofString("{\"card_number\":\"4111111111111111\",\"month\":\"11\",\"year\":\"2020\",\"cvv\":\"423\",\"mid\":\"5e5f454c3b2518365c7923f4\"}"));

HttpRequest request = builder.build();
HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.body());
```

_Node.js_

```node
const credentials = Buffer.from('{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}').toString('base64');

const response = await fetch('https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}}', {
  method: 'PUT',
  headers: {
    'Authorization': `Basic ${credentials}`,
    'Content-Type': 'application/json',
  },
  body: JSON.stringify({
    "card_number": "4111111111111111",
    "month": "11",
    "year": "2020",
    "cvv": "423",
    "mid": "5e5f454c3b2518365c7923f4"
  }),
});

const data = await response.json();
```

_Go_

```go
package main

import (
    "fmt"
    "io"
    "net/http"
    "strings"
)

func main() {
    payload := strings.NewReader("{\"card_number\":\"4111111111111111\",\"month\":\"11\",\"year\":\"2020\",\"cvv\":\"423\",\"mid\":\"5e5f454c3b2518365c7923f4\"}")
    req, _ := http.NewRequest("PUT", "https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}}", payload)
    req.Header.Set("Content-Type", "application/json")
    req.SetBasicAuth("{{YOUR_API_KEY}}", "{{YOUR_SECRET_KEY}}")

    res, _ := http.DefaultClient.Do(req)
    defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)
    fmt.Println(string(body))
}
```

_.NET_

```dotnet
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

var credentials = Convert.ToBase64String(Encoding.ASCII.GetBytes("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}"));

var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Put, "https://payments.pabbly.com/api/v1/paymentmethod/{{customer_id}}");
request.Headers.TryAddWithoutValidation("Authorization", $"Basic {credentials}");
request.Content = new StringContent("{\"card_number\":\"4111111111111111\",\"month\":\"11\",\"year\":\"2020\",\"cvv\":\"423\",\"mid\":\"5e5f454c3b2518365c7923f4\"}");
request.Content.Headers.ContentType = new MediaTypeHeaderValue("application/json");

var response = await client.SendAsync(request);
var data = await response.Content.ReadAsStringAsync();
Console.WriteLine(data);
```

---

**Other endpoints in Payment Method:**

- [POST /paymentmethod/{{customer_id}} — Create Payment Method](/subscription-billing/payment-method/create-payment-method)
- [GET /paymentmethods/{{customer_id}} — List All Payment Methods By Customer Id](/subscription-billing/payment-method/list-all-payment-methods-by-customer-id)

